#ifndef _H_LIBCX_FORMAT_BASE_TYPES
#define _H_LIBCX_FORMAT_BASE_TYPES

#include <cx/string.hpp>

extern "C" {
int snprintf(char* __restrict s, size_t maxlen, const char* __restrict format, ...);
}

template <typename T>
struct Formatter;

template <>
struct Formatter<int> {
    static String fmt_to_str(const int& val) {
        char buf[32];
        snprintf(buf, sizeof(buf), "%d", val);
        return String(buf);
    }
};

template <>
struct Formatter<const char*> {
    static String fmt_to_str(const char* val) {
        return String(val);
    }
};

template <>
struct Formatter<char*> {
    static String fmt_to_str(char* val) {
        return String(val);
    }
};

template <>
struct Formatter<float> {
    static String fmt_to_str(const float& val) {
        char buf[32];
        snprintf(buf, sizeof(buf), "%f", val);
        return String(buf);
    }
};

template <>
struct Formatter<double> {
    static String fmt_to_str(const double& val) {
        char buf[32];
        snprintf(buf, sizeof(buf), "%f", val);
        return String(buf);
    }
};

#endif // !_H_LIBCX_FORMAT_BASE_TYPES
