#ifndef _H_LIBCX_FORMAT_OBJ_FMT_HELPER
#define _H_LIBCX_FORMAT_OBJ_FMT_HELPER

#include <stddef.h>
#include <cx/format/fmt.hpp>
#include <cx/string.hpp>
#include <cx/collections/vec.hpp>

class ObjFmtHelper {
private:
    String buffer = String();
    size_t nest_level = 0;

public:
    ObjFmtHelper(const char* name) {
        buffer.push_str(name);
        buffer.push_str(" {\n");
    };

    ObjFmtHelper(int level, const char* name) {
        this->nest_level = level;
        buffer.push_str(name);
        buffer.push_str(" {\n");
    };

    ~ObjFmtHelper() = default;

    template <Format T>
    void add_field(const char* name, T val) {
        for (size_t i = 0; i < nest_level + 1; i++) {
            this->buffer.push_str("    ");
        }
        auto s = format("{}: {}\n", name, val);
        this->buffer.push_str(s);
    }

    String finish() {
        this->buffer.push_str("}\n");
        return this->buffer;
    }
};

#endif // !_H_LIBCX_FORMAT_OBJ_FMT_HELPER
