#ifndef _H_LIBCX_HASH_HASH
#define _H_LIBCX_HASH_HASH

#include <stdint.h>
#include <cx/stl.hpp>
#include <sys/types.h>

#define HASH_SIZE 4

template <typename T>
struct Hasher;

template <typename T>
concept Hash = requires(T t) {
    { t.hash() } -> stl::same_as<uint8_t[HASH_SIZE]>;
} || requires(T t) {
    { Hasher<T>::hash(t) } -> stl::same_as<u_int8_t[HASH_SIZE]>;
};
#endif // !_H_LIBCX_HASH_HASH
