#ifndef _H_LIBCX_IO_PRINT
#define _H_LIBCX_IO_PRINT

#include <cx/format/fmt.hpp>

extern "C" {
int putchar(int c);
}

template <typename... Types>
void print(const char* fmt, Types... args) {
    String s = format(fmt, args...);
    char* cs = s.as_cstr();
    for (int i = 0; i < s.len(); i++) {
        putchar(cs[i]);
    }
}

template <typename... Types>
void println(const char* fmt, Types... args) {
    print(fmt, args...);
    putchar('\n');
}

#endif // !_H_LIBCX_IO_PRINT
