#ifndef _H_LIBCX_STL_ADD_LVALUE_REF
#define _H_LIBCX_STL_ADD_LVALUE_REF

#include <cx/stl/is_referenceable.hpp>

#if __has_builtin(__add_lvalue_reference)

template <class _Tp>
using __add_lvalue_reference_t = __add_lvalue_reference(_Tp);

#else

template <class _Tp, bool = __is_referenceable_v<_Tp>>
struct __add_lvalue_reference_impl {
    using type = _Tp;
};

template <class _Tp>
struct __add_lvalue_reference_impl<_Tp, true> {
    using type = _Tp&;
};

template <class _Tp>
using __add_lvalue_reference_t = typename __add_lvalue_reference_impl<_Tp>::type;

#endif // __has_builtin(__add_lvalue_reference)

template <class _Tp>
struct add_lvalue_reference {
    using type = __add_lvalue_reference_t<_Tp>;
};

template <class _Tp>
using add_lvalue_reference_t = __add_lvalue_reference_t<_Tp>;
#endif // _H_LIBCX_STL_ADD_LVALUE_REF
