#ifndef _H_LIBCX_STL_INTEGRAL_CONSTANT
#define _H_LIBCX_STL_INTEGRAL_CONSTANT

template <class _Tp, _Tp __v>
struct integral_constant {
    static inline constexpr const _Tp value = __v;
    typedef _Tp value_type;
    typedef integral_constant type;

    constexpr operator value_type() const {
        return value;
    }

    constexpr value_type operator()() const {
        return value;
    }
};

typedef integral_constant<bool, true> true_type;
typedef integral_constant<bool, false> false_type;

template <bool _Val>
using _BoolConstant = integral_constant<bool, _Val>;

template <bool __b>
using bool_constant = integral_constant<bool, __b>;

#endif // _H_LIBCX_STL_INTEGRAL_CONSTANT