#ifndef _H_LIBCX_STL_IS_SAME
#define _H_LIBCX_STL_IS_SAME

// Basic type trait
template <typename T, typename U>
struct is_same {
    static constexpr bool value = false;
};

template <typename T>
struct is_same<T, T> {
    static constexpr bool value = true;
};

// Short helper
template <typename T, typename U>
inline constexpr bool is_same_v = is_same<T, U>::value;

// Concept version (like std::same_as)
template <typename T, typename U>
concept same_as = is_same_v<T, U> && is_same_v<U, T>;

#endif // _H_LIBCX_STL_IS_SAME