#include <stdlib.h>
#include <unistd.h>

extern "C" void* emulate_cc_new(unsigned long len) {
    void* p = malloc(len);
    if (p == 0) {
        (void)!write(2, "out of memory\n", 14);
        abort();
    }
    return p;
}

extern "C" void emulate_cc_delete(void* p) {
    if (p != 0) {
        free(p);
    }
}

extern "C" void emulate_cc_delete_sized(void* p, unsigned long) {
    emulate_cc_delete(p);
}

void* operator new(unsigned long len) __attribute__((alias("emulate_cc_new")));
void* operator new[](unsigned long len) __attribute__((alias("emulate_cc_new")));
void operator delete(void* p) noexcept __attribute__((alias("emulate_cc_delete")));
void operator delete[](void* p) noexcept __attribute__((alias("emulate_cc_delete")));
void operator delete(void* p, unsigned long) noexcept __attribute__((alias("emulate_cc_delete_sized")));
void* __cxa_pure_virtual = 0;
void* __gxx_personality_v0 = 0; //! program will die if an exception is thrown
